﻿
Public Class Form1
    Dim creditStr As String = "(C) 7M4MON 2023"
    Dim vsetStr As String = "VSET "
    Dim isetStr As String = "ISET "


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '保存された設定のロード
        LoadSettings()
    End Sub





    Private Sub LoadSettings()
        Try
            With My.Settings
                NudVolt.Value = .setVoltagee
                NudCurrent.Value = .setCurrent
                TbVisaAddress.Text = .visaAddressString
            End With
        Catch ex As Exception

        End Try

    End Sub
    Private Sub SaveSettings()
        Try
            With My.Settings
                .setVoltagee = NudVolt.Value
                .setCurrent = NudCurrent.Value
                .visaAddressString = TbVisaAddress.Text

            End With
        Catch ex As Exception

        End Try
    End Sub

    'フォームが閉じる時に設定を保存する
    Private Sub Form1_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        SaveSettings()
    End Sub



    '参照のVISA32.vbから、VISA32.DLLを呼び出してVISAで通信する
    Private Sub SendCommand(visaAddress As String, visaCommandString As String)
        Try
            Dim resourceManager As Integer = 0, viError As Integer
            Dim session As Integer = 0
            viError = visa32.viOpenDefaultRM(resourceManager)
            viError = visa32.viOpen(resourceManager, visaAddress,
                            visa32.VI_NO_LOCK, visa32.VI_TMO_IMMEDIATE, session)
            'Also, since you are using SOCKET connections, you will need to enable the termination character, 
            'or all of your viScanf/viQueryf calls will fail. To do that, add this code after the viOpen calls:
            'viSetAttribute(session, VI_ATTR_TERMCHAR_EN, VI_TRUE)

            viError = visa32.viPrintf(session, visaCommandString & vbLf)

            If viError = 0 Then
                Debug.Print("OK")
            Else
                Debug.Print("NG")
            End If
            ' infomationLbl.Text = Now.ToString("HH:mm:ss") + ", " + visaAddress + ", " + visaCommandString + ", " + viError.ToString

            'Dim replyString As System.Text.StringBuilder =
            '                New System.Text.StringBuilder(1000)
            'viError = visa32.viScanf(session, "%s", replyString)
            'replyLbl.Text = replyString.ToString()
            visa32.viClose(session)
            visa32.viClose(resourceManager)

        Catch ex As Exception
            Debug.Print("ERROR, " + Now.ToString("HH:mm:ss") + ", " + visaAddress + ", " + visaCommandString)
        End Try
    End Sub

    Private Sub BtnSet_Click(sender As Object, e As EventArgs) Handles BtnSet.Click
        SendCommand(TbVisaAddress.Text, vsetStr & NudVolt.Value.ToString & "V")
        SendCommand(TbVisaAddress.Text, isetStr & NudCurrent.Value.ToString & "A")
        ' SendCommand(TbVisaAddress.Text, "VOLT 1V")
    End Sub

    Private Sub BtnOff_Click(sender As Object, e As EventArgs) Handles BtnOff.Click
        SendCommand(TbVisaAddress.Text, vsetStr & "0V")
        SendCommand(TbVisaAddress.Text, isetStr & "0A")
    End Sub
End Class